import GLOOP.*;
public class Kerze{
    private GLZylinder koerper, docht;
    private GLLicht flamme;

    private double dicke, laenge;
    private boolean an;

    public Kerze(double pX,double pZ, double pDicke, double pLaenge){
        //Zustandsvariablen setzen
        dicke = pDicke;
        laenge = pLaenge;
        an = true;

        //Kerzenkoerper erstellen
        koerper = new GLZylinder (pX,laenge/2,pZ, dicke,laenge);
        koerper.drehe(90,0,0);  
        koerper.setzeFarbe(1,0,0);

        //Docht erstellen
        docht = new GLZylinder (pX, laenge+5, pZ, 3,10);
        docht.drehe(90,0,0); 
        docht.setzeFarbe(0,0,0);   

        //Flamme erstellen
        flamme = new GLLicht(pX,laenge+25,pZ);
        flamme.setzeSichtbarkeit(true);
        flamme.setzeFarbe(1,1,0.5);  
        flamme.skaliere(1,2,1);
    }

    public void aus(){    
        //Flamme verstecken und Licht ausschalten
        flamme.setzeSichtbarkeit(false);
        flamme.setzeFarbe(0,0,0);
        an = false;
    }

    public void an(){
        //Flamme zeigen und Licht einschalten
        flamme.setzeSichtbarkeit(true);
        flamme.setzeFarbe(1,1,0.5);
        an = true;
    }

    public void brenneAb(){
        if (an) {
            //Abbrenngeschrindigkeit in Abhngigkeit von der Dicke
            double g =  (50/dicke) /1000;

            //Kerzenkoerper durch Skalierung verkleinern
            koerper.skaliere(1, 1, 1.0 - (g/laenge));

            //Bestandteile verchieben
            koerper.verschiebe(0,-g/2,0);
            docht.verschiebe(0,-g,0);
            flamme.verschiebe(0,-g,0);

            //Attribut anpasse
            laenge = laenge-g;
        }

        //Kerze geht ggf. aus
        if (laenge < 20){
            this.aus();
        }
    }
    
}
